"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../../..");
var chai_1 = require("chai");
describe(__filename + "#", function () { return __awaiter(void 0, void 0, void 0, function () {
    var cases, engine, _loop_1, _i, cases_1, _a, source, inference;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                cases = [
                    [
                        "{a}",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "{a.b}",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 0,
                                        fromSpread: false,
                                        properties: {
                                            b: {
                                                optional: false,
                                                value: {
                                                    kind: 2
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "{{a, b, c: [d, {e, f: b.d}]}}",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                },
                                b: {
                                    optional: false,
                                    value: {
                                        kind: 0,
                                        fromSpread: false,
                                        properties: {
                                            d: {
                                                optional: false,
                                                value: {
                                                    kind: 2
                                                }
                                            }
                                        }
                                    }
                                },
                                d: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                },
                                e: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "{a.b} {a.c}",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 0,
                                        fromSpread: false,
                                        properties: {
                                            b: {
                                                optional: false,
                                                value: {
                                                    kind: 2
                                                }
                                            },
                                            c: {
                                                optional: false,
                                                value: {
                                                    kind: 2
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<span {a}></span>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<span a={a}></span>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<span {...a}></span>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 0,
                                        fromSpread: true,
                                        properties: {}
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<div a={<div>{a}</div>}></div>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<div component as=\"a\">\n        {a}\n      </div>{b}",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                a: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                },
                                b: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<div component as=\"a\" class:test=\"test\">\n      </div>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                test: {
                                    optional: true,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ],
                    [
                        "<div component as=\"a\" class:test=\"test\">\n        {test}\n      </div>",
                        {
                            kind: 0,
                            fromSpread: false,
                            properties: {
                                test: {
                                    optional: false,
                                    value: {
                                        kind: 2
                                    }
                                }
                            }
                        }
                    ]
                ];
                return [4 /*yield*/, __1.createEngine({})];
            case 1:
                engine = _b.sent();
                _loop_1 = function (source, inference) {
                    it("can infer " + source, function () {
                        var ast = engine.parseContent(String(source));
                        chai_1.expect(__1.infer(ast)).to.eql(inference);
                    });
                };
                for (_i = 0, cases_1 = cases; _i < cases_1.length; _i++) {
                    _a = cases_1[_i], source = _a[0], inference = _a[1];
                    _loop_1(source, inference);
                }
                return [2 /*return*/];
        }
    });
}); });
